#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 100;
const int SH = MAXN * MAXN;

bool dp[MAXN + 1][MAXN + 1][2 * SH + 1];

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    dp[0][0][SH] = true;
    for (int x = 0; x < n; x++) {
        for (int y = 0; y <= m; y++) {
            for (int d = SH - x * m; d <= SH + x * m; d++) {
                if (!dp[x][y][d]) {
                    continue;
                }

                // left
                if (y > 0) {
                    if (x == 0 || a[x - 1][y - 1] != a[x][y - 1]) {
                        dp[x][y - 1][d] = true;
                    }
                }
                //right
                if (y < m) {
                    if (x == 0 || a[x - 1][y] != a[x][y]) {
                        dp[x][y + 1][d] = true;
                    }
                }
                // down
                if (y == 0 || y == m || a[x][y - 1] != a[x][y]) {
                    dp[x + 1][y][d + y - (m - y)] = true;
                }
            }
        }

        for (int y = m - 1; y >= 0; y--) {
            for (int d = SH - x * m; d <= SH + x * m; d++) {
                if (!dp[x][y][d]) {
                    continue;
                }

                // left
                if (y > 0) {
                    if (x == 0 || a[x - 1][y - 1] != a[x][y - 1]) {
                        dp[x][y - 1][d] = true;
                    }
                }
                //right
                if (y < m) {
                    if (x == 0 || a[x - 1][y] != a[x][y]) {
                        dp[x][y + 1][d] = true;
                    }
                }
                // down
                if (y == 0 || y == m || a[x][y - 1] != a[x][y]) {
                    dp[x + 1][y][d + y - (m - y)] = true;
                }
            }
        }
    }

    int ans = SH;
    for (int y = 0; y <= m; y++) {
        for (int d = 0; d <= 2 * SH; d++) {
            if (dp[n][y][d]) {
                ans = min(ans, abs(d - SH));
            }
        }
    }

    cout << ans << endl;

    return 0;
}
